<?php
/**
 * MainController
 */

/** revisions
 * DMW 1/12/15 1:58 PM - Add Air China to split as they are added for Okura now.
 * 
 *  
 */
class MainController extends DCUController
{

    public function index()
    {

        // Just replace these
        // Doo::loadCore('app/DooSiteMagic');
        // DooSiteMagic::displayHome();

        //
        // Load hotels into $this->data['hotels']
        //
        $hfile = $this->gethotels('global/splitfiles/hotels.txt');
        $lines = explode("\n", $hfile);
        $this->data['hotels'] = array();
        foreach ($lines as $value)
        {
            if ( !empty($value) )
            {
                //print_r($value. '<br><br>');
                $hotel = explode("~", $value);
                //print_r($hotel[1] . '<br><br>');
                $ihotel[ 'P'.$hotel[1] ] = $hotel;
                $this->data['hotels'] = array_merge($this->data['hotels'], $ihotel);
            }
        }

        // Split the files.
        $fo = Doo::loadClass('DooFile', TRUE);
        $flist = $fo->getList('global/splitfiles');
        foreach ($flist as $fname)
        {
            // Make sure we process the airline files.
            if ( strpos('CA_NIK|AA_NIK|DL_NIK', strtoupper(substr($fname["name"], 0, 6))) === FALSE )
            {
                continue;
            }

            // Init vars
            $nikkolines = array();
            $okuralines = array();
            $badlines   = array();

            $airlinecode = strtoupper(substr($fname["name"], 0, 6));
            echo "Processing " . $fname["name"] . '...<br/>';

            // Get the file contents
            $o = Doo::loadClass('DooFile', TRUE);
            $filecontent = $o->readFileContents($fname["path"]);
            $filelines = explode("\n", $filecontent);


            // Get the property code from the file.
            // It is the last element on comma-separated line.
            $i = 0;
            $recs = 0;
            $header = '';
            $trailer = '';
            $JHCcount = 0;
            $OHCcount = 0;
            foreach ($filelines as $oneline)
            {
                // Ignore blank lines
                if ( empty($oneline) )
                {
                    continue;
                }

                // line counter
                $i++;

                // Save the header line
                if ( $i == 1 )
                {
                    $header = $oneline;
                    continue;
                }

                // Save the trailer line
                if ( substr($oneline, 0, 2) == '$$' or substr($oneline, 0, 2) == '99' or 
                        substr($oneline, 0, 1) == '3' )
                {
                    $trailer = $oneline;
                    continue;
                }

                //
                // Get prop code if AA
                //
                if ( $airlinecode == 'AA_NIK' )
                {
                    $r = explode(',', $oneline);
                    $propcode = $r[count($r) - 1];
                }

                //
                // Get prop code if DL
                //
                if ( $airlinecode == 'DL_NIK' )
                {
                    $propcode = substr($oneline, 108, 5);
                }

                //
                // Get prop code if CA
                //
                if ( $airlinecode == 'CA_NIK' )
                {
                    $propcode = trim(substr($oneline, 41, 6));
                }

                // Check for blank propcodes.
                if ( !empty($propcode) )
                {
                    $chain = $this->getchaincode($propcode);
                }
                else
                {
                    $badlines = array_merge($badlines, array($oneline));
                }

                echo 'Propcode: ' . $propcode . '<br/><br/>';
                echo 'chaincode: ' . $chain . '<br/><br/>';

                // Check for blank chain found.
                if ( !empty($chain) )
                {
                    if ( strpos(strtoupper($chain), 'NIKKO') !== FALSE or
                            strpos(strtoupper($chain), 'JAL') !== FALSE)
                    {
                        $nikkolines = array_merge($nikkolines, array($oneline));
                        $JHCcount++;
                        echo '---------- NIKKO FILE ----------------<br/><br/>';

                    }
                    else
                    {
                        if ( strpos(strtoupper($chain), 'OKURA') !== FALSE )
                        {
                            // Adjust DL detail line to convert to OKURA format.
                            if ( $airlinecode == 'DL_NIK' )
                            {
                                $oneline = str_replace('JALHNKJALHNK', 'OKUHOKOKUHOK', $oneline);
                                $oneline = str_replace('PROMO     JLDBG', 'PROMO          ', $oneline);
                            }

                            $okuralines = array_merge($okuralines, array($oneline));
                            $OHCcount++;
                        echo '---------- OHC FILE ----------------<br/><br/>';
                        }
                        else
                        {
                            $badlines = array_merge($badlines, array($oneline));
                            echo '---------- BAD FILE ----------------<br/><br/>';
                        }
                    }
                }
                else
                {
                    $badlines = array_merge($badlines, array($oneline));
                    echo '---------- real bad FILE ----------------<br/><br/>';

                }
            }
            echo '<br><br>';
            var_dump($okuralines);
            echo '<br><br>';
            var_dump($nikkolines);
            echo '<br><br>';
            var_dump($badlines);
            echo '<br><br>';

            // On AA files, the header and trailer are the same for JHC and OHC.
            $OHCheader = $header;
            $JHCheader = $header;
            $OHCtrailer = $trailer;
            $JHCtrailer = $trailer;

            // Create new header new trailer if CA file.
            if ( $airlinecode == 'CA_NIK' )
            {
                $OHCheader = str_ireplace('JALJALHOTELS', 'OKUOKURA    ', $header);
                $OHCtrailer = str_ireplace(substr($trailer, 0, 7), '3' . str_pad($OHCcount, 6, '0', STR_PAD_LEFT), $trailer);
                $JHCtrailer = str_ireplace(substr($trailer, 0, 7), '3' . str_pad($JHCcount, 6, '0', STR_PAD_LEFT), $trailer);
            }

            // Create new headers and trailers if DL file.
            if ( $airlinecode == 'DL_NIK' )
            {
                // Update OHC header
                $OHCheader = str_ireplace('01V2MICJAL', '01V1OKUOKU', $header);
                $OHCheader = substr($OHCheader, 0, 24) . '-' . substr($OHCheader, 24, 2) .
                        '-' . substr($OHCheader, 26, 2) . ' ' . substr($OHCheader, 27, 2) .
                        ':' . substr($OHCheader, 29, 2) . ':' . substr($OHCheader, 31, 2) .
                        substr($OHCheader, 34, 311);

                // Update OHC trailer
                $OHCtrailer = str_ireplace('99V2MICJAL', '99V1OKUOKU', $trailer);
                $OHCtrailer = substr($OHCtrailer, 0, 24) . '-' . substr($OHCtrailer, 24, 2) .
                        '-' . substr($OHCtrailer, 26, 2) . ' ' . substr($OHCtrailer, 27, 2) .
                        ':' . substr($OHCtrailer, 29, 2) . ':' . substr($OHCtrailer, 31, 2) .
                        substr($OHCtrailer, 34, 316);
                $OHCtrailer = substr($OHCtrailer, 0, 54) . sprintf('%09d', $OHCcount) .
                        str_repeat(' ', 287);

                // Set JHC header.
                $JHCheader = $header;

                // Update JHC trailer - rec count.
                $JHCtrailer = substr($trailer, 0, 54) . sprintf('%09d', $JHCcount) .
                        substr($trailer, 63, 287);

            }

            // Get a file helper
            $rfile = Doo::loadClass('DooFile', TRUE);

            // OHC file
            $okuralines = array_merge(array($OHCheader), $okuralines, array($OHCtrailer));
            $ohcfilecontent = implode("\n", $okuralines) . "\n";
            $rfile->create('global/splitfiles/OHC_' . $fname["name"], $ohcfilecontent);

            // JHC file
            $nikkolines = array_merge(array($JHCheader), $nikkolines, array($JHCtrailer));
            $jhcfilecontent = implode("\n", $nikkolines) . "\n";
            $rfile->create('global/splitfiles/JHC_' . $fname["name"], $jhcfilecontent);

            // BAD file
            $badlines = array_merge(array('--- bad lines ---'), $badlines, array('--- bad lines ---'));
            $badfilecontent = implode("\n", $badlines) . "\n";
            $rfile->create('global/splitfiles/BAD_' . $fname["name"], $badfilecontent);

        }
    }


    private function getchaincode($propcode)
    {
        foreach ($this->data['hotels'] as $oneprop)
        {
            if ( strpos($oneprop[3], $propcode) !== FALSE )
            {
                return($oneprop[4]);
            }
        }
    }


    private function gethotels($fname = null)
    {
        $o = Doo::loadClass('DooFile', TRUE);
        return($o->readFileContents($fname));

    }
}
